//audio
datablock AudioProfile(stockshotgunFireSound)
{
   filename    = "./shotgunShoot.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(stockshotgunReloadSound)
{
   filename    = "./shotgunReload.wav";
   description = AudioClose3d;
   preload = true;
};

//shell
datablock DebrisData(stockshotgunShellDebris)
{
	shapeFile = "./shotgunShell.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = -399.9;
	elasticity = 0.35;
	friction = 0.1;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 3;
};

//emitter
datablock ParticleData(stockshotgunSmokeParticle)
{
	dragCoefficient      = 4;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 1;
	constantAcceleration = 0.0;
	lifetimeMS           = 250;
	lifetimeVarianceMS   = 25;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;

	colors[0]     = "0.72 0.65 0.34 0.25";
	colors[1]     = "0.44 0.39 0.34 0.15";
	colors[2]     = "0.36 0.34 0.34 0.00";

	sizes[0]      = 0.3;
	sizes[1]      = 0.35;
	sizes[2]      = 0.9;

	times[0]      = 0;
	times[1]      = 0.1;
	times[2]      = 1.0;

	useInvAlpha = true;
};
datablock ParticleEmitterData(stockshotgunSmokeEmitter)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 0;
   ejectionVelocity = 9;
   velocityVariance = 8;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 30;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "stockshotgunSmokeParticle";
};

datablock ParticleData(tf2bulletImpactParticle : gunExplosionRingParticle)
{
	colors[0]     	= "0.94 0.39 0.11 1.0";
	colors[1]     	= "0.47 0.19 0.05 0.9";
	colors[2]    	= "0.24 0.11 0.02 0.8";

	sizes[0]      = 0.5;
	sizes[1]      = 0;

};

datablock ParticleEmitterData(tf2bulletImpactEmitter : gunExplosionRingEmitter)
{

   particles = "tf2bulletImpactParticle";

};

datablock ExplosionData(tf2bulletExplosion : gunExplosion)
{
   soundProfile = bulletHitSound;
   particleDensity = 0;
   emitter[0] = tf2bulletImpactEmitter;
   explosionScale = "0.5 0.5 0.5";
   lightStartColor = "0 0 0";
};

datablock ParticleData(tf2ShTrail)
{
   dragCoefficient      = 1;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 40;
   lifetimeVarianceMS   = 0;
   textureName          = "base/data/particles/dot";
   spinSpeed		= 0.0;
   spinRandomMin	= 0.0;
   spinRandomMax	= 0.0;

   colors[0]     	= "0.94 0.39 0.11 1.0";
   colors[1]     	= "0.47 0.19 0.05 0.9";
   colors[2]    	= "0.24 0.11 0.02 0.8";

   sizes[0]      	= 0.075;
   sizes[1]      	= 0.035;
   sizes[2]      	= 0.010;

   useInvAlpha = false;
};

datablock ParticleEmitterData(tf2ShTrailE)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 0.1;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "tf2ShTrail";
};

AddDamageType("stockShotgun",   '<bitmap:add-ons/Weapon_Shotgun/CI_shotgun> %1',    '%2 <bitmap:add-ons/Weapon_Shotgun/CI_shotgun> %1',0.5,1);
datablock ProjectileData(stockshotgunProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 6;
   directDamageType    = $DamageType::Shotgun;
   radiusDamageType    = $DamageType::Shotgun;
   particleEmitter     = tf2ShTrailE;

   brickExplosionRadius = 0.2;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 15;
   brickExplosionMaxVolume = 20;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 30;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 100;
   verticalImpulse     = 0;
   explosion           = tf2bulletExplosion;

   muzzleVelocity      = 1000;
   velInheritFactor    = 0;

   armingDelay         = 0;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};

//////////
// item //
//////////
datablock ItemData(stockshotgunItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./shotgun.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Shotgun";
	iconName = "./shotgunIcon";
	doColorShift = true;
	colorShiftColor = "0.85 0.94 1.00 1.000";

	 // Dynamic properties defined by the scripts
	image = stockshotgunImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(stockshotgunImage)
{
   // Basic Item properties
   shapeFile = "./shotgun.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0.35 0.5 -0.55"; // +rightleft- +fowardback- +updown-
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = stockshotgunItem;
   ammo = " ";
   projectile = stockshotgunProjectile;
   projectileType = Projectile;

   casing = stockshotgunShellDebris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   minShotTime = 1000;

   doColorShift = true;
   colorShiftColor = stockshotgunItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.15;
	stateTransitionOnTimeout[0]     = "Ready";
	stateSound[0]			  = weaponSwitchSound;

	stateName[1]                    = "Ready";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateAllowImageChange[1]        = true;
	stateTimeoutValue[1]		  = 0.01;

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Reload";
	stateTimeoutValue[2]            = 0.416;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "shoot";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]		  = true;
	stateEmitter[2]			  = stockshotgunSmokeEmitter;
	stateEmitterTime[2]		  = 0.05;
	stateEmitterNode[2]		  = "muzzleNode";
	stateSound[2]			  = stockshotgunFireSound;

	stateName[3]			  = "Reload";
	stateTimeoutValue[3]		  = 1;
	stateSequence[3]		  = "pump";
	stateTransitionOnTimeout[3]	  = "Wait";
	stateWaitForTimeout[3]		  = true;
	stateEjectShell[3]       	  = true;
	stateSound[3]			  = stockshotgunReloadSound;
	
	stateName[4]			  = "Wait";
	stateTimeoutValue[4]		  = 0.05;
	stateTransitionOnTimeout[4]	  = "Ready";
};

function stockshotgunImage::onFire(%this,%obj,%slot)
{
	if((%obj.lastFireTime+%this.minShotTime) > getSimTime())
		return;
	%obj.lastFireTime = getSimTime();
      
	%obj.playThread(2, shiftRight);
   	%obj.playThread(3, shiftLeft);

	%projectile = %this.projectile;
	%spread = 0.0025;
	%shellcount = 10;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}